﻿using Hotline.Application.Orders;
using Hotline.Orders;
using Hotline.Share.Dtos.Order;
using Hotline.Share.Enums.Order;
using Shouldly;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XF.Domain.Repository;

namespace Hotline.Application.Tests.Application;
public class OrderApplicationTest
{
    private readonly IOrderApplication _orderApplication;
    private readonly IRepository<OrderVisit> _orderVisitRepository;

    public OrderApplicationTest(IOrderApplication orderApplication, IRepository<OrderVisit> orderVisitRepository)
    {
        _orderApplication = orderApplication;
        _orderVisitRepository = orderVisitRepository;
    }

    [Theory]
    [InlineData(1)]
    [InlineData(2)]
    [InlineData(3)]
    [InlineData(4)]
    [InlineData(5)]
    [InlineData(6)]
    [InlineData(7)]
    public async Task VisitPushSMS_Test(int count)
    {
        var orderVisit = await _orderVisitRepository.Queryable()
            .Where(m => m.VisitState == EVisitState.WaitForVisit)
            .OrderByDescending(m => m.CreationTime)
            .FirstAsync();
        orderVisit.ShouldNotBeNull("缺少 回访单 (order_visit) VisitState = 10 的数据.");
        var dto = new VisitSmsInDto
        {
            Ids = new List<string> { orderVisit.Id }
        };
        await _orderApplication.VisitPushSMSAsync(dto, new CancellationToken());
        var visit = await _orderVisitRepository.Queryable().Where(m => m.Id == orderVisit.Id).FirstAsync();
        visit.VisitState.ShouldBe(EVisitState.SMSVisiting);
        visit.VisitType.ShouldBe(EVisitType.SmsVisit);
    }
}
