﻿using Hotline.CallCenter.Calls;
using Hotline.Share.Enums.Order;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using XF.Domain.Repository;

namespace Hotline.Repository.SqlSugar.CallCenter;
public interface ICallNativeRepository : IRepository<CallNative>
{
    Task<int> UpdateReplyTxtAsync(string callId, string replyTxt);

    /// <summary>
    /// 根据 OrderId 返回用户电话评价枚举
    /// 默认返回 默认满意
    /// </summary>
    /// <param name="orderId"></param>
    /// <returns></returns>
    Task<EVoiceEvaluate> GetReplyVoiceOrDefaultByOrderIdAsync(string orderId);

    /// <summary>
    /// 根据 OrderId 查询实体
    /// </summary>
    /// <param name="orderId"></param>
    /// <returns></returns>
    Task<CallNative?> GetByOrderIdAsync(string orderId);
}
